% Example with two paired 

% return a cell with available ports.
ce = getPortNames() 

baudrate = 9600;

writerPort = openPort(ce{1}, baudrate);
readerPort = openPort(ce{2}, baudrate);

% String we will print out to serial port
string = '$Hello World, hope you are well and happily happy$';

% Must convert to uint8 before sending out data
dataOut = uint8(string); 

% Always use this two argument form where portPointer is untouched from the
% open port and data is a 1d vector of uint8 values to send out data
writePort(writerPort, dataOut);

% Try and read N bytes
numBytesToRead = length(dataOut);

% This function will access the ports buffer and try to read the number of
% bytes specified by numBytesToRead. This function will timeout in a few
% milliseconds if the buffer has less data then numBytesToRead and will
% return all the contents that were in the buffer upon timeout. If the
% buffer contains more data than numBytesToRead then leftOverBytesInBuffer
% will tell you how many bytes remain in the buffer after the read operation
[dataIn , leftOverBytesInBuffer] = readPort(readerPort, numBytesToRead);
char(dataIn)

% Close the port when you are all finished...
% if you forget to close it
% unplugging and replugging the serial device will allow you to re-open the
% device
closePort(readerPort);
closePort(writerPort);
